<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { storeToRefs } from 'pinia';
import { ref, computed, watch, inject } from 'vue';
import Modal from '@/components/general/Modal.vue';
import Switch from '@/components/general/form/Switch.vue';
import Input from '@/components/general/form/Input.vue';
import TextEditor from '@/components/general/form/TextEditor.vue';
import Embedded from '@/components/general/Embedded.vue';
import { useMetaStore } from '@/stores/meta';
import { useFreeformStore } from '@/stores/freeform';
import { useScheduleStore } from '@/stores/schedule';
import { useTimelineStore } from '@/stores/timeline';
import { paneTypes, handleModeEnum, itemEnum } from '@/enums/enums';
import useFreeform from '@/hooks/useFreeform';
import useSchedule from '@/hooks/useSchedule';
import useTimeline from '@/hooks/useTimeline';
import UploadDropArea from '@/components/general/form/UploadDropArea.vue';
import AudioRecorder from '@/components/general/form/AudioRecorder.vue';
import type { item } from '@/components/general/form/BoxSelector.vue';
import BoxSelector from '@/components/general/form/BoxSelector.vue';
import ColorSwatch from '@/components/general/form/ColorSwatch.vue';
import { useI18n } from 'vue-i18n';
import { textClear } from '@/lib/utils';

const { t } = useI18n();
const $t = t;

const meta = useMetaStore();
const { paneType } = storeToRefs(meta);
const configuration = inject<any>('configuration');

let store = null;
let paneMethods:any = null;
if(paneType.value === paneTypes.FREEFORM){
    store = useFreeformStore();
    paneMethods = useFreeform();
}
else if(paneType.value === paneTypes.SCHEDULE || paneType.value === paneTypes.STREAM){
    store = useScheduleStore();
    paneMethods = useSchedule();
}
else if(paneType.value === paneTypes.TIMELINE){
    store = useTimelineStore();
    paneMethods = useTimeline();
}

//@ts-ignore
const { file, elementTitle, elementText, elementInfo, elementBody, handleMode, getHashcode, getStyle, commentIndex, elementColor } = storeToRefs(store);

const emits = defineEmits<{
    (e: 'close'):void
}>();

const onlyFileUpload = ref(elementBody?.value?.type === 'file');
const deleteFileLocal = ref(false);
const showAudioRecorder = ref(false);
const showFileUploader = ref(true);
const recordFinished = ref(false);

const cancel = ()=>{
    onlyFileUpload.value = false;
    elementTitle.value = '';
    elementText.value = '';
    elementInfo.value = '';
    elementBody.value = null;
    deleteFileLocal.value = false;
    file.value = null;
    emits('close');
}

const submit = async ()=>{
    if(handleMode.value === handleModeEnum.EDIT || handleMode.value === handleModeEnum.COMMENT_EDIT){
        await paneMethods.editPost({title: elementTitle.value,text: elementText.value, info: elementInfo.value, deleteFile: deleteFileLocal.value});
    }else{
        await paneMethods.createPost({title: elementTitle.value,text: elementText.value, info: elementInfo.value});
    }
    cancel();
}

const deleteFile = ()=>{
    deleteFileLocal.value = true;
    onlyFileUpload.value = false;
    elementText.value = "";
}

const isFile = computed(()=>{
    if(elementBody.value)
        return elementBody.value.type === 'file';
})

const isPost = computed(()=>{
    return elementBody.value?false:true;
})

watch(onlyFileUpload, (value, oldValue)=>{
    if(value){
        elementInfo.value = elementText.value;
        showAudioRecorder.value = true;
    }else{
        elementText.value = elementInfo.value;
        elementInfo.value = "";
        deleteFileLocal.value = true;
        showAudioRecorder.value = false;
        file.value = null;
    }
});

const handleRecorder = (value: boolean)=>{
    if(value){
        showFileUploader.value = !value;
        recordFinished.value = false;
        file.value = null;
    }
}

const handleRecorderFinished = (value: boolean)=>{
    if(value){
        recordFinished.value = true;
    }
}

const header = computed(()=>{
    if(handleMode.value === handleModeEnum.ADD)
        return $t('contentPage.post.add');
    else if(handleMode.value === handleModeEnum.EDIT)
        return $t('contentPage.post.edit');
    else if(handleMode.value === handleModeEnum.COMMENT_ADD)
        return "Kommentar hinzufügen";
    else if(handleMode.value === handleModeEnum.COMMENT_EDIT)
        return "Kommentar bearbeiten";    

});

let colors: item[] = (commentIndex.value!==-1 || paneType.value === (paneTypes.SCHEDULE || paneTypes.STREAM))? configuration.style.commentColors: configuration.style.shapeColors;

</script>
<template>
<Modal :header="header" :labelCancel="$t('general.buttons.cancel')" @cancel="cancel" 
    @submit="submit" :disableSubmit="(onlyFileUpload && (showAudioRecorder && !recordFinished && !file))||(!onlyFileUpload && (!elementTitle && !textClear(elementText)))" :labelSubmit="handleMode===handleModeEnum.EDIT || handleMode===handleModeEnum.COMMENT_EDIT?$t('contentPage.editSubmit'):$t('contentPage.addSubmit')" :font="getStyle?.font?getStyle.font:''">
    <div class="flex flex-col gap-2 mt-2">
        <input class="opacity-0 absolute w-0.5 h-0.5" name="username" type="text" hidden />
        <input class="opacity-0 absolute w-0.5 h-0.5" name="password" type="password" hidden />
        <Input v-model="elementTitle" type="text" :label="$t('contentPage.post.headline')" :placeholder="$t('contentPage.post.headline')" :autofocus="true" v-if="commentIndex===-1"/>
        <div class="">
            <label>Farbe:</label>
            <div class="flex flex-col gap-1">
                <BoxSelector v-model="elementColor" :items="colors"
                    :identifier="itemEnum.VALUE" type="colors" />
                <ColorSwatch v-model="elementColor" />
            </div>
        </div>
        <Switch v-model="onlyFileUpload" :header="$t('contentPage.post.upload.label')" :label="$t('adjustPanel.general.true')"/>
        <div class="w-full flex justify-center" v-if="handleMode===handleModeEnum.EDIT && isFile && elementBody!==null && !deleteFileLocal && onlyFileUpload">
            <div class="size-52 relative">
                <button class="bg-gray-100 size-8 rounded-full text-2xl hover:bg-gray-200 absolute -right-5 -top-5 text-red-700"  @click="deleteFile"><i class="ri-delete-bin-line"></i></button>
                <Embedded :body="elementBody" :url="elementText"  :hideUrl="true" imgSize="200px" style="text-align:center"/>
            </div>
        </div>
        <div v-if="(onlyFileUpload && showFileUploader)">
            <UploadDropArea v-model="file" :error="$t('contentPage.post.upload.error')" :accept="configuration.uploadFileAccept"/>
        </div>
        <div v-if="(onlyFileUpload && showAudioRecorder)">
            <label>{{$t('contentPage.post.record.header')}}</label>
            <AudioRecorder v-model="file" @record="handleRecorder" @finished="handleRecorderFinished"/>
        </div>
        <div v-if="!(onlyFileUpload)">
            <label>{{$t("contentPage.post.content")}}</label>
            <div class="border border-gray-300 rounded-md" :style="{backgroundColor: elementColor}">
                <TextEditor v-model="elementText" :hideButtons="true" />
            </div>
        </div>
        <div v-if="onlyFileUpload">
            <label>{{$t("contentPage.post.info")}}</label>
            <div class="border border-gray-300 rounded-md" :style="{backgroundColor: elementColor}">
                <TextEditor v-model="elementInfo" :hideButtons="true"/>
            </div>
        </div>
    </div>
</Modal>
</template>